<!-- manual page source format generated by PolyglotMan v3.0.7, -->
<!-- available via anonymous ftp from ftp.cs.berkeley.edu:/ucb/people/phelps/tcltk/rman.tar.Z -->

<HTML>
<HEAD>
<TITLE>Man page for private_prop.1</TITLE>
</HEAD>
<BODY bgcolor=white>
<A HREF="#toc">Table of Contents</A><P>

<H2><A NAME="sect0" HREF="#toc0">Name</A></H2>

<P>
private_prop - propagate privatization information interprocedurally

<H2><A NAME="sect1" HREF="#toc1"><B>Synopsis</B></A></H2>

<P>
<B>private_prop</B> <B>-pre-pass</B> <I>infile</I> <I>outfile</I> { <I>infile</I> <I>outfile</I> }*
<P>
<B>rescope</B> <I>infile</I> <I>outfile</I> { <I>infile</I> <I>outfile</I> }*
<P>
<B>private_prop</B> <I>infile</I> <I>outfile</I> { <I>infile</I> <I>outfile</I> }*

<H2><A NAME="sect2" HREF="#toc2"><B>Description</B></A></H2>

<P>
The <I>private</I><B>_</B><I>prop</I> program propagates information about
which globals are privatized onto all the procedures in
which the private copies might be used. It reads the
``privatized'' and ``reduced'' annotes on tree_for nodes
to find privatized globals and writes out its results as
lists of symbols in ``possible global privatizable'' annotations
on the proc_syms.
<P>
This pass assumes that if a callsite has either of the
annotations ``call mod syms'' or ``call ref syms'', then
there is at most one of each of these annotations at the
callsite and that if a global variable is read or written
by the callee or anything it calls at any level, that
variable is listed in at least one of these two annotations.
If a callsite has neither of these annotations,
this pass assumes that any global might be read or written
on the other side of the callsite.
<P>
This pass also assumes that if there are any indirect
calls (calls through pointers) or calls to external procedures
(any procedures that are not defined in the files
given to this pass), no privatized globals are used on the
other side of the call. It's up to the pass that finds
parallelization and marks privatizable variables to insure
this is the case.
<P>
Since this pass sometimes needs to move variables from
file scope to inter-file scope, it needs to use the
<B>rescope</B> pass. So this pass needs to be run with the
``-pre-pass'' option, then <B>rescope</B> can be run, then this
pass can be run again to do the actual work.

<H2><A NAME="sect3" HREF="#toc3"><B>See</B> <B>Also</B></A></H2>

<P>
<A HREF="man_rescope.1.html">rescope(1)</A>
 <A HREF="man_pgen.1.html">pgen(1)</A>


<H2><A NAME="sect4" HREF="#toc4"><B>History</B></A></H2>

<P>
This program was written by Chris Wilson.
<P>

<HR><P>
<A NAME="toc"><B>Table of Contents</B></A><P>
<UL>
<LI><A NAME="toc0" HREF="#sect0">Name</A></LI>
<LI><A NAME="toc1" HREF="#sect1">Synopsis</A></LI>
<LI><A NAME="toc2" HREF="#sect2">Description</A></LI>
<LI><A NAME="toc3" HREF="#sect3">See Also</A></LI>
<LI><A NAME="toc4" HREF="#sect4">History</A></LI>
</UL>
</BODY></HTML>
